/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.ripartizione.dbmodel.jooq.tables.records;


import com.alkemy.sophia.ripartizione.dbmodel.jooq.tables.ImportiAnticipo;

import java.math.BigDecimal;
import java.sql.Timestamp;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record12;
import org.jooq.Row12;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class ImportiAnticipoRecord extends UpdatableRecordImpl<ImportiAnticipoRecord> implements Record12<Integer, Timestamp, Timestamp, String, BigDecimal, BigDecimal, Integer, BigDecimal, BigDecimal, String, BigDecimal, BigDecimal> {

    private static final long serialVersionUID = -1807672029;

    /**
     * Setter for <code>IMPORTI_ANTICIPO.ID_IMPORTO_ANTICIPO</code>.
     */
    public void setIdImportoAnticipo(Integer value) {
        set(0, value);
    }

    /**
     * Getter for <code>IMPORTI_ANTICIPO.ID_IMPORTO_ANTICIPO</code>.
     */
    public Integer getIdImportoAnticipo() {
        return (Integer) get(0);
    }

    /**
     * Setter for <code>IMPORTI_ANTICIPO.PERIODO_PERTINENZA_INIZIO</code>.
     */
    public void setPeriodoPertinenzaInizio(Timestamp value) {
        set(1, value);
    }

    /**
     * Getter for <code>IMPORTI_ANTICIPO.PERIODO_PERTINENZA_INIZIO</code>.
     */
    public Timestamp getPeriodoPertinenzaInizio() {
        return (Timestamp) get(1);
    }

    /**
     * Setter for <code>IMPORTI_ANTICIPO.PERIODO_PERTINENZA_FINE</code>.
     */
    public void setPeriodoPertinenzaFine(Timestamp value) {
        set(2, value);
    }

    /**
     * Getter for <code>IMPORTI_ANTICIPO.PERIODO_PERTINENZA_FINE</code>.
     */
    public Timestamp getPeriodoPertinenzaFine() {
        return (Timestamp) get(2);
    }

    /**
     * Setter for <code>IMPORTI_ANTICIPO.NUMERO_FATTURA</code>.
     */
    public void setNumeroFattura(String value) {
        set(3, value);
    }

    /**
     * Getter for <code>IMPORTI_ANTICIPO.NUMERO_FATTURA</code>.
     */
    public String getNumeroFattura() {
        return (String) get(3);
    }

    /**
     * Setter for <code>IMPORTI_ANTICIPO.IMPORTO_ORIGINALE</code>.
     */
    public void setImportoOriginale(BigDecimal value) {
        set(4, value);
    }

    /**
     * Getter for <code>IMPORTI_ANTICIPO.IMPORTO_ORIGINALE</code>.
     */
    public BigDecimal getImportoOriginale() {
        return (BigDecimal) get(4);
    }

    /**
     * Setter for <code>IMPORTI_ANTICIPO.IMPORTO_UTILIZZABILE</code>.
     */
    public void setImportoUtilizzabile(BigDecimal value) {
        set(5, value);
    }

    /**
     * Getter for <code>IMPORTI_ANTICIPO.IMPORTO_UTILIZZABILE</code>.
     */
    public BigDecimal getImportoUtilizzabile() {
        return (BigDecimal) get(5);
    }

    /**
     * Setter for <code>IMPORTI_ANTICIPO.ID_INVOICE</code>.
     */
    public void setIdInvoice(Integer value) {
        set(6, value);
    }

    /**
     * Getter for <code>IMPORTI_ANTICIPO.ID_INVOICE</code>.
     */
    public Integer getIdInvoice() {
        return (Integer) get(6);
    }

    /**
     * Setter for <code>IMPORTI_ANTICIPO.IMPORTO_ACCANTONATO</code>.
     */
    public void setImportoAccantonato(BigDecimal value) {
        set(7, value);
    }

    /**
     * Getter for <code>IMPORTI_ANTICIPO.IMPORTO_ACCANTONATO</code>.
     */
    public BigDecimal getImportoAccantonato() {
        return (BigDecimal) get(7);
    }

    /**
     * Setter for <code>IMPORTI_ANTICIPO.PERCENTUALE_ACCANTONAMENTO</code>.
     */
    public void setPercentualeAccantonamento(BigDecimal value) {
        set(8, value);
    }

    /**
     * Getter for <code>IMPORTI_ANTICIPO.PERCENTUALE_ACCANTONAMENTO</code>.
     */
    public BigDecimal getPercentualeAccantonamento() {
        return (BigDecimal) get(8);
    }

    /**
     * Setter for <code>IMPORTI_ANTICIPO.NOTE</code>.
     */
    public void setNote(String value) {
        set(9, value);
    }

    /**
     * Getter for <code>IMPORTI_ANTICIPO.NOTE</code>.
     */
    public String getNote() {
        return (String) get(9);
    }

    /**
     * Setter for <code>IMPORTI_ANTICIPO.IMPORTO_ACCANTONATO_UTILIZZABILE</code>.
     */
    public void setImportoAccantonatoUtilizzabile(BigDecimal value) {
        set(10, value);
    }

    /**
     * Getter for <code>IMPORTI_ANTICIPO.IMPORTO_ACCANTONATO_UTILIZZABILE</code>.
     */
    public BigDecimal getImportoAccantonatoUtilizzabile() {
        return (BigDecimal) get(10);
    }

    /**
     * Setter for <code>IMPORTI_ANTICIPO.IMPORTO_UTILIZZATO_RECLAMI</code>.
     */
    public void setImportoUtilizzatoReclami(BigDecimal value) {
        set(11, value);
    }

    /**
     * Getter for <code>IMPORTI_ANTICIPO.IMPORTO_UTILIZZATO_RECLAMI</code>.
     */
    public BigDecimal getImportoUtilizzatoReclami() {
        return (BigDecimal) get(11);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Record1<Integer> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Record12 type implementation
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Row12<Integer, Timestamp, Timestamp, String, BigDecimal, BigDecimal, Integer, BigDecimal, BigDecimal, String, BigDecimal, BigDecimal> fieldsRow() {
        return (Row12) super.fieldsRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Row12<Integer, Timestamp, Timestamp, String, BigDecimal, BigDecimal, Integer, BigDecimal, BigDecimal, String, BigDecimal, BigDecimal> valuesRow() {
        return (Row12) super.valuesRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field1() {
        return ImportiAnticipo.IMPORTI_ANTICIPO.ID_IMPORTO_ANTICIPO;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Timestamp> field2() {
        return ImportiAnticipo.IMPORTI_ANTICIPO.PERIODO_PERTINENZA_INIZIO;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Timestamp> field3() {
        return ImportiAnticipo.IMPORTI_ANTICIPO.PERIODO_PERTINENZA_FINE;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field4() {
        return ImportiAnticipo.IMPORTI_ANTICIPO.NUMERO_FATTURA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<BigDecimal> field5() {
        return ImportiAnticipo.IMPORTI_ANTICIPO.IMPORTO_ORIGINALE;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<BigDecimal> field6() {
        return ImportiAnticipo.IMPORTI_ANTICIPO.IMPORTO_UTILIZZABILE;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field7() {
        return ImportiAnticipo.IMPORTI_ANTICIPO.ID_INVOICE;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<BigDecimal> field8() {
        return ImportiAnticipo.IMPORTI_ANTICIPO.IMPORTO_ACCANTONATO;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<BigDecimal> field9() {
        return ImportiAnticipo.IMPORTI_ANTICIPO.PERCENTUALE_ACCANTONAMENTO;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field10() {
        return ImportiAnticipo.IMPORTI_ANTICIPO.NOTE;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<BigDecimal> field11() {
        return ImportiAnticipo.IMPORTI_ANTICIPO.IMPORTO_ACCANTONATO_UTILIZZABILE;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<BigDecimal> field12() {
        return ImportiAnticipo.IMPORTI_ANTICIPO.IMPORTO_UTILIZZATO_RECLAMI;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component1() {
        return getIdImportoAnticipo();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Timestamp component2() {
        return getPeriodoPertinenzaInizio();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Timestamp component3() {
        return getPeriodoPertinenzaFine();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component4() {
        return getNumeroFattura();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public BigDecimal component5() {
        return getImportoOriginale();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public BigDecimal component6() {
        return getImportoUtilizzabile();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component7() {
        return getIdInvoice();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public BigDecimal component8() {
        return getImportoAccantonato();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public BigDecimal component9() {
        return getPercentualeAccantonamento();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component10() {
        return getNote();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public BigDecimal component11() {
        return getImportoAccantonatoUtilizzabile();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public BigDecimal component12() {
        return getImportoUtilizzatoReclami();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value1() {
        return getIdImportoAnticipo();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Timestamp value2() {
        return getPeriodoPertinenzaInizio();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Timestamp value3() {
        return getPeriodoPertinenzaFine();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value4() {
        return getNumeroFattura();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public BigDecimal value5() {
        return getImportoOriginale();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public BigDecimal value6() {
        return getImportoUtilizzabile();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value7() {
        return getIdInvoice();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public BigDecimal value8() {
        return getImportoAccantonato();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public BigDecimal value9() {
        return getPercentualeAccantonamento();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value10() {
        return getNote();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public BigDecimal value11() {
        return getImportoAccantonatoUtilizzabile();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public BigDecimal value12() {
        return getImportoUtilizzatoReclami();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public ImportiAnticipoRecord value1(Integer value) {
        setIdImportoAnticipo(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public ImportiAnticipoRecord value2(Timestamp value) {
        setPeriodoPertinenzaInizio(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public ImportiAnticipoRecord value3(Timestamp value) {
        setPeriodoPertinenzaFine(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public ImportiAnticipoRecord value4(String value) {
        setNumeroFattura(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public ImportiAnticipoRecord value5(BigDecimal value) {
        setImportoOriginale(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public ImportiAnticipoRecord value6(BigDecimal value) {
        setImportoUtilizzabile(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public ImportiAnticipoRecord value7(Integer value) {
        setIdInvoice(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public ImportiAnticipoRecord value8(BigDecimal value) {
        setImportoAccantonato(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public ImportiAnticipoRecord value9(BigDecimal value) {
        setPercentualeAccantonamento(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public ImportiAnticipoRecord value10(String value) {
        setNote(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public ImportiAnticipoRecord value11(BigDecimal value) {
        setImportoAccantonatoUtilizzabile(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public ImportiAnticipoRecord value12(BigDecimal value) {
        setImportoUtilizzatoReclami(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public ImportiAnticipoRecord values(Integer value1, Timestamp value2, Timestamp value3, String value4, BigDecimal value5, BigDecimal value6, Integer value7, BigDecimal value8, BigDecimal value9, String value10, BigDecimal value11, BigDecimal value12) {
        value1(value1);
        value2(value2);
        value3(value3);
        value4(value4);
        value5(value5);
        value6(value6);
        value7(value7);
        value8(value8);
        value9(value9);
        value10(value10);
        value11(value11);
        value12(value12);
        return this;
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached ImportiAnticipoRecord
     */
    public ImportiAnticipoRecord() {
        super(ImportiAnticipo.IMPORTI_ANTICIPO);
    }

    /**
     * Create a detached, initialised ImportiAnticipoRecord
     */
    public ImportiAnticipoRecord(Integer idImportoAnticipo, Timestamp periodoPertinenzaInizio, Timestamp periodoPertinenzaFine, String numeroFattura, BigDecimal importoOriginale, BigDecimal importoUtilizzabile, Integer idInvoice, BigDecimal importoAccantonato, BigDecimal percentualeAccantonamento, String note, BigDecimal importoAccantonatoUtilizzabile, BigDecimal importoUtilizzatoReclami) {
        super(ImportiAnticipo.IMPORTI_ANTICIPO);

        set(0, idImportoAnticipo);
        set(1, periodoPertinenzaInizio);
        set(2, periodoPertinenzaFine);
        set(3, numeroFattura);
        set(4, importoOriginale);
        set(5, importoUtilizzabile);
        set(6, idInvoice);
        set(7, importoAccantonato);
        set(8, percentualeAccantonamento);
        set(9, note);
        set(10, importoAccantonatoUtilizzabile);
        set(11, importoUtilizzatoReclami);
    }
}
